(**Lazy Lists with self-made laziness*)
(* type llist *)
type 'a cell = Nil | Cons of ('a * 'a llist)
and 'a llist = (unit -> 'a cell)
(* hd : 'a llist -> 'a *)
let hd xs = match xs() with Nil       -> failwith "empty"
                          | Cons(x,_) -> x
(* from : int -> int llist *)
let rec from n = fun() -> Cons(n,from(n+1))
(* to_list : int -> int llist -> int list *)
let rec to_list n xs = if n < 1 then [] else match xs() with
 | Nil        -> []
 | Cons(x,xs) -> x :: to_list (n-1) xs
(* tl : 'a llist -> 'a llist *)
let tl xs = match xs() with Nil        -> failwith "empty"
                          | Cons(_,xs) -> xs
(* zip_with : ('a -> 'b -> 'c) -> 'a llist -> 'b llist -> 'c llist *)
let rec zip_with f xs ys = fun() -> match (xs(),ys()) with
 | (Cons(x,xs),Cons(y,ys)) -> Cons(f x y,zip_with f xs ys)
 | _                       -> Nil
(* fibs : int llist *)
let rec fibs = 
 fun() -> Cons(0,fun() -> Cons(1, zip_with (+) fibs (tl fibs)))

